'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _wrapDisplayName = require('recompose/wrapDisplayName');

var _wrapDisplayName2 = _interopRequireDefault(_wrapDisplayName);

var _lodash = require('lodash.debounce');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var defaultGetHeight = function defaultGetHeight() {
  var elem = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  if (elem && elem.clientHeight) {
    return elem.clientHeight;
  }
  if (elem && elem.getBoundingClientRect) {
    return elem.getBoundingClientRect().height;
  }
  return undefined;
};

var defaultGetWidth = function defaultGetWidth() {
  var elem = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  if (elem && elem.clientWidth) {
    return elem.clientWidth;
  }
  if (elem && elem.getBoundingClientRect) {
    return elem.getBoundingClientRect().width;
  }
  return undefined;
};

var defaultTransform = function defaultTransform(width, height) {
  return { containerWidth: width, containerHeight: height };
};

var defaultContainerStyle = {
  width: '100%',
  height: '100%',
  padding: 0,
  border: 0
};

var defaultDebounceOptions = {
  leading: false,
  trailing: true,
  maxWait: 800
};

var withDimension = function withDimension() {
  var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var _ref$transform = _ref.transform;
  var transform = _ref$transform === undefined ? defaultTransform : _ref$transform;
  var _ref$containerStyle = _ref.containerStyle;
  var containerStyle = _ref$containerStyle === undefined ? defaultContainerStyle : _ref$containerStyle;
  var _ref$getHeight = _ref.getHeight;
  var getHeight = _ref$getHeight === undefined ? defaultGetHeight : _ref$getHeight;
  var _ref$getWidth = _ref.getWidth;
  var getWidth = _ref$getWidth === undefined ? defaultGetWidth : _ref$getWidth;
  var _ref$wait = _ref.wait;
  var wait = _ref$wait === undefined ? 200 : _ref$wait;
  var _ref$debounceOptions = _ref.debounceOptions;
  var debounceOptions = _ref$debounceOptions === undefined ? defaultDebounceOptions : _ref$debounceOptions;
  return function (BaseComponent) {
    var _class, _temp2;

    return _temp2 = _class = function (_Component) {
      _inherits(_class, _Component);

      function _class() {
        var _Object$getPrototypeO;

        var _temp, _this, _ret;

        _classCallCheck(this, _class);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(_class)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.state = {
          containerWidth: null,
          containerHeight: null
        }, _this.update = function (elem) {
          _this.setState({
            containerWidth: getWidth(elem),
            containerHeight: getHeight(elem)
          });
        }, _this.updateDimensions = function () {
          var elem = _this.refs.withDimensionContainer;

          if (!_this.canUpdate) {
            return;
          }
          if (_this.state.containerWidth === getWidth(elem) && _this.state.containerHeight === getHeight(elem)) {
            return;
          }

          if (typeof window !== 'undefined' && window !== null && window.requestAnimationFrame) {
            window.requestAnimationFrame(function () {
              return _this.update(elem);
            });
          } else {
            _this.update(elem);
          }
        }, _temp), _possibleConstructorReturn(_this, _ret);
      }

      _createClass(_class, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          if (typeof window !== 'undefined' && window !== null && window.addEventListener) {
            this.canUpdate = true;
            this.debouncedUpdate = (0, _lodash2.default)(this.updateDimensions, wait, debounceOptions);
            window.addEventListener('resize', this.debouncedUpdate, { passive: true });
            this.debouncedUpdate();
          }
        }
      }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
          if (this.debouncedUpdate) {
            this.debouncedUpdate();
          }
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          if (typeof window !== 'undefined' && window !== null && window.removeEventListener) {
            this.canUpdate = false;
            window.removeEventListener('resize', this.debouncedUpdate, { passive: true });
          }
        }
      }, {
        key: 'render',
        value: function render() {
          return _react2.default.createElement(
            'div',
            {
              ref: 'withDimensionContainer',
              style: containerStyle
            },
            _react2.default.createElement(BaseComponent, _extends({}, transform(this.state.containerWidth, this.state.containerHeight), this.props))
          );
        }
      }]);

      return _class;
    }(_react.Component), _class.displayName = (0, _wrapDisplayName2.default)(BaseComponent, 'withDimension'), _temp2;
  };
};

exports.default = withDimension;